// Seamonkey specific functions for MinimizeToTray

if (!('extensions' in window))
    window.extensions = new Array();

if (!('mook' in window.extensions))
    window.extensions.mook = new Array();

if (!('minimizetotray' in window.extensions.mook))
    window.extensions.mook.minimizetotray = 
    function(){
        // this is a stub only
        throw Components.results.NS_ERROR_ABORT;
    };

    window.extensions.mook.minimizetotray
.trayCallback = 
function ( aEvent, aParam, aKeyMask, aMouseX, aMouseY ) {
    // note that |this| is the function itself
    var self = window.extensions.mook.minimizetotray;
    var iface = Components.interfaces.trayIWindowCallback;
    var rv = false;
    switch (aEvent) {        
        case iface.EVENT_MOUSEDBLCLK_LEFT:
            //regardless of options, if something goes bad, we
            //want to have double click default to restore.
            self.restore();
            rv = true;
            break;
        case iface.EVENT_MOUSEUP_LEFT:
            try {
 	        //if the user selected the option to only have a double
	        //click restore the window, then don't process this
                if (!self.m_prefs.getBoolPref(
                        self.k_pref_prefix + 'two-click-restore')) { 
                    self.restore();
                    rv = true;	         
                }
            }
            catch (ex) {}
            break;	
        case iface.EVENT_MOUSEUP_RIGHT:
            var popup = document.getElementById(
                self.k_xul_prefix + 'traypopup');
            self.showPopup( popup, aMouseX, aMouseY );
            rv = true;
            break;
    }
    return rv;
};


    window.extensions.mook.minimizetotray
.turboMode = 
function ( ) {
    throw(
        '-turbo mode for Seamonkey is not available.\n' +
        'use the built-in version instead.  This should not ' +
        'have been possible to call at all, since the switch was ' +
        'overwritten in C++...'
        );
    return;
};

// WA: Fullscreen minimize-button Overlay
function mtt_minimizebuttonOnClick(event) {
    if(event.button==2) {
        if(event.ctrlKey) {
            window.extensions.mook.minimizetotray.minimizeAll();
        } else {
            window.extensions.mook.minimizetotray.minimizeWindow();
        }
    } else if(event.button==1) {
        window.extensions.mook.minimizetotray.minimizeAll();
    }
}

function mtt_minimizebuttonOnCommand() {
    if(window.extensions.mook.minimizetotray.
       m_prefs.getBoolPref(window.extensions.mook.minimizetotray.
                           k_pref_prefix + 'always')) {
        window.extensions.mook.minimizetotray.minimizeWindow();
    } else {
        window.minimize();
    }
}

// signal that the app-specific parts have done loading
window.extensions.mook.minimizetotray.m_bLoadedApp = true;
